import "Vector3" for Vector3
import "TurokRWHelpers" for TurokRWInterface, CGameObjectInstance, CPlayer

// Sensitivty scale
var M_MUL = 1
// Vertical sensitivity
var M_PITCH = 0.0015
// Horizontal sensitivity
var M_YAW = 0.0015

// Target fps
var FPSMODE = TurokRWInterface.FPS60 //FPS15, FPS30, FPS60, FPSMAX
var FPSSCALE = TurokRWInterface.FPS60SCALE //FPS15SCALE, FPS30SCALE, FPS60SCALE

// Not implemented; ignore
var SCALETOFPS = false

// Time before mouse input begins; softlocks in the main menu
var TIMEBEFOREEXECUTE = 700

// Do not touch below!

// Userdata
var PITCH = 0
var YAW = 0
var DELTAX = 0
var DELTAY = 0
var PPOINTER = 0
var PPOINTERLAST = 0
var PLAYER = CPlayer.new()

// Constants
var RAD2DEG = 57.29578049
var DEG2RAD = 0.01745329
var TAU = Num.pi * 2
var HPI = Num.pi / 2
var MINA = -89.999998 * DEG2RAD
var MAXA = 89.999998 * DEG2RAD

class mupen {
    // Get rdram methods from C
    foreign static rdramRead8(addr)
    foreign static rdramWrite8(addr, input)
    foreign static rdramRead16(addr)
    foreign static rdramWrite16(addr, input)
    foreign static rdramRead32(addr)
    foreign static rdramReadf32(addr)
    foreign static rdramWrite32(addr, input)
    foreign static rdramWritef32(addr, input)
    foreign static rdramReadBuffer(addr, length)
    foreign static rdramWriteBuffer(addr, buf)

    // Get rom methods from C
    foreign static romRead8(addr)
    foreign static romWrite8(addr, input)
    foreign static romRead16(addr)
    foreign static romWrite16(addr, input)
    foreign static romRead32(addr)
    foreign static romWrite32(addr, input)
    foreign static romReadf32(addr)
    foreign static romWritef32(addr, input)
    foreign static romReadBuffer(addr, length)
    foreign static romWriteBuffer(addr, buf)

    // Impleneted these just for this
    foreign static getMouseX()
    foreign static getMouseY()

    foreign static osdMessage(msg, corner)

    static init() {}

    static onTick(framecount) {
        if (framecount > TIMEBEFOREEXECUTE) {
            /* Set FPS
            rdramWrite32(0x800051C0, 0)
            rdramWrite32(0x8009253C, 0)
            rdramWrite8(0x80119B26, FPSMODE)
            rdramWrite8(0x80119C66, FPSMODE)    
            rdramWrite8(0x80119DA6, FPSMODE)
            rdramWritef32(0x80140C3C, FPSSCALE)*/

            // Set player pointer
            PPOINTER = rdramRead32(TurokRWInterface.pCPlayerPointer)
            if (PPOINTER != PPOINTERLAST) {
                PPOINTERLAST = PPOINTER
                PLAYER = CPlayer.new(PPOINTER)
            }

            if (PPOINTER != 0) {
                var oldp = PITCH
                var oldy = YAW
                PITCH = PITCH - (getMouseY() * M_PITCH * M_MUL)
                YAW = YAW + (getMouseX() * M_YAW * M_MUL)

                PITCH = PITCH > MAXA && MAXA || PITCH < MINA && MINA || PITCH
                YAW = YAW > TAU && YAW - TAU || YAW < -TAU && YAW + TAU || YAW

                DELTAX = PITCH - oldp
                DELTAY = oldy - YAW

                rdramWritef32(PLAYER.m_vHeadRotOffset, PITCH)
                rdramWritef32(PLAYER.character.m_RotY, YAW)
            }
        }

        if (framecount % 48 == 0) {
            if (framecount < TIMEBEFOREEXECUTE) {
                var delta = TIMEBEFOREEXECUTE - framecount
                System.print("Waiting to execute... %(delta) frames before execution!")
            } else {
                System.print("Angles: rad; %(PITCH), %(YAW) deg; %(PITCH * RAD2DEG), %(YAW * RAD2DEG)")
            }
        }
    }
}